#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/*

// 1. model
DS2ModelFile_1
1.0
karl
model_actor
Z:\gameres\textures\!actors\kar.tga
notexture
notexture
notexture
notexture

// 2. level
DS2GeometryFile_1
0.8
DS2Chunk_begin
meshes
default_lightmap
Z:\gameres\textures\industry\mtorec
notexture
notexture
notexture
notexture

*/

struct vector3f
{
	float x,y,z; 
};

struct vector2f
{
	float u,v; 
};

struct vectorT3f
{
	vector3f p;	//position
  float tx,ty;	//texture coords
};

int main(int argc, char* argv[])
{
	char oobj;
	float f;
	int fpos;
  unsigned short blkid,cntw=0,mcntw;
  unsigned long i, j, k;
  unsigned char c,cnt=0,mcnt;
	char fileName[256];
  FILE *inputFile;
	unsigned short * m_Indices;
	vectorT3f * m_Vertices;
	vector3f * m_Normales;
	printf("DS2Engine (YouAreEmpty) ds2md model,level parser [201205xx]\n");
	if (argc < 2) 
  {
		printf("usage: parse_yae < srcfile.ds2md >\n");
		return 1;
	}
	
	if (argc > 2) oobj = 1;

	strcpy((char*)fileName,argv[1]);

  inputFile = fopen(fileName,"rb");
	if(!inputFile)
  {
 	printf("ERR: cannot open.\n");
  return 1;
  }
///////////////////////////////////////////
	fseek(inputFile,0x00,SEEK_SET);
	fread(&i,4,1,inputFile); // type
	switch(i)
	{
	case 0x5344000E:
		{
///////////////////////////////////////////
		printf(" * DS2ModelFile detected\n");
		fseek(inputFile,0x10,SEEK_SET);

		fread(&blkid,sizeof(unsigned short),1,inputFile); // version
		fpos = ftell(inputFile);
		fread(&j,4,1,inputFile); j &= 0xFFFFFF; 
		if (j == 0x362E30) blkid += 4; // read 4 byte padding for version 0.6
		fpos += blkid; fseek(inputFile,fpos,SEEK_SET);

		if (j != 0x362E30)
		{
		fread(&blkid,sizeof(unsigned short),1,inputFile); // name
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&mcnt,1,1,inputFile); // mesh count
		printf("mesh count = %u\n",mcnt);
		} else {
		fread(&mcnt,1,1,inputFile); // mesh count
		fread(&c,1,1,inputFile); // pad for version 0.6
		printf("mesh count = %u\n",mcnt);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // name
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		}

again:
		fread(&blkid,sizeof(unsigned short),1,inputFile); // shader
		char * m_shd = new char[blkid+1];
		fread(m_shd,blkid,1,inputFile); 
	  m_shd[blkid] = 0;
	  printf("(%u): shader : '%s', ",cnt,m_shd);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // texture

		char * tmpdata = new char[blkid];
		fread(tmpdata,blkid,1,inputFile); 
		unsigned int tstart = 0, tend = blkid;
		for (fpos = 0; fpos < blkid; fpos++)
		{
		if (tmpdata[fpos] == '.') tend = fpos;
		else if (tmpdata[fpos] == '\\') fpos++, tstart = fpos;
		}
		char * m_dds = new char[tend - tstart + 1];
		memcpy(m_dds,&tmpdata[tstart],tend - tstart); 
    m_dds[tend - tstart] = 0;
	  printf("texture : '%s'\n",m_dds);
		delete [] tmpdata;

		fread(&blkid,sizeof(unsigned short),1,inputFile); // unk, 'notexture'
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // unk, 'notexture'
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // unk, 'notexture'
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // unk, 'notexture'
		fpos = ftell(inputFile) + blkid; 
		if (j == 0x362E30) fseek(inputFile,fpos,SEEK_SET); else // fseek(inputFile,fpos+33,SEEK_SET);
		{
		fseek(inputFile,fpos,SEEK_SET);
		fread(&f,sizeof(float),1,inputFile); printf("  f(1) = %f\n",f);
		fread(&f,sizeof(float),1,inputFile); printf("  f(2) = %f\n",f);
		fread(&f,sizeof(float),1,inputFile); printf("  f(3) = %f\n",f);
		fread(&f,sizeof(float),1,inputFile); printf("  f(4) = %f\n",f);
		fread(&f,sizeof(float),1,inputFile); printf("  f(5) = %f\n",f);
		fread(&f,sizeof(float),1,inputFile); printf("  f(6) = %f\n",f);
		fread(&f,sizeof(float),1,inputFile); printf("  f(7) = %f\n",f);
		fread(&f,sizeof(float),1,inputFile); printf("  f(8) = %f\n",f);
		fread(&c,1,1,inputFile); // pad 
		}

		if (j != 0x362E30)
		{
		unsigned int icount;
    fread(&icount,sizeof(unsigned int),1,inputFile);
    printf(" idxc = %u\n",icount);
    printf(" idx at 0x%08X (size %u)\n",ftell(inputFile),icount*sizeof(unsigned short));
		m_Indices = new unsigned short[icount];
		fread(m_Indices, sizeof(unsigned short), icount, inputFile );

		unsigned int vcount = 0, vtx;
    fread(&vcount,sizeof(unsigned short),1,inputFile);
    printf(" vtxc = %u\n",vcount);
    printf(" vtx at 0x%08X (size %u)\n",ftell(inputFile),vcount*sizeof(vector3f));
		m_Vertices = new vectorT3f[vcount];
		for (vtx = 0; vtx < vcount;vtx++)
		fread(&m_Vertices[vtx].p, sizeof(vector3f), 1, inputFile );
		m_Normales = new vector3f[vcount];
    printf(" nrm at 0x%08X (size %u)\n",ftell(inputFile),vcount*sizeof(vector3f));
		fread(m_Normales, sizeof(vector3f), vcount, inputFile );
    printf(" u_v at 0x%08X (size %u)\n",ftell(inputFile),vcount*sizeof(vector2f));
		for (vtx = 0; vtx < vcount;vtx++)
		fread(&m_Vertices[vtx].tx, sizeof(vector2f), 1, inputFile );
		} else {
		unsigned int vcount = 0, vtx, icount;
		fread(&f,sizeof(float),1,inputFile); // pad for version 0.6
    fread(&vcount,sizeof(unsigned int),1,inputFile);
    fread(&icount,sizeof(unsigned int),1,inputFile);
		fread(&c,1,1,inputFile); // pad 
    printf(" vtxc = %u\n",vcount);
    printf(" vtx at 0x%08X (size %u)\n",ftell(inputFile),vcount*sizeof(vector3f));
    printf(" nrm at 0x%08X (size %u)\n",ftell(inputFile),vcount*sizeof(vector3f));
    printf(" u_v at 0x%08X (size %u)\n",ftell(inputFile),vcount*sizeof(vector2f));
		m_Vertices = new vectorT3f[vcount];
		m_Normales = new vector3f[vcount];
		for (vtx = 0; vtx < vcount;vtx++)
		{
		fread(&m_Vertices[vtx].p, sizeof(vector3f), 1, inputFile );
		fread(&m_Normales[vtx], sizeof(vector3f), 1, inputFile );
		fread(&m_Vertices[vtx].tx, sizeof(vector2f), 1, inputFile );
		}
    printf(" idxc = %u\n",icount);
    printf(" idx at 0x%08X (size %u)\n",ftell(inputFile),icount*sizeof(unsigned short));
		m_Indices = new unsigned short[icount];
		fread(m_Indices, sizeof(unsigned short), icount, inputFile );
		}

		delete [] m_Indices;
		delete [] m_Vertices;
		delete [] m_Normales;

		cnt++;

		if (cnt < mcnt)
		{
    printf(" nextblk at 0x%08X\n",ftell(inputFile));
    fpos = ftell(inputFile);
    for (;;)
		{
		fseek(inputFile,fpos,SEEK_SET);
		if (fread(&i,4,1,inputFile) == 0) break;
		if (i == 0x65746F6E) // 'note'
		{

		printf("--> match another at 0x%08X\r",fpos);
		for (i = 0;i < 3;) 
		{
		fseek(inputFile,fpos,SEEK_SET); fread(&c,1,1,inputFile); 
		if (!c) 
			{
			fseek(inputFile,fpos-2,SEEK_SET); fread(&c,1,1,inputFile); if (!c) i = 3;
			fseek(inputFile,fpos-3,SEEK_SET); fread(&c,1,1,inputFile); if (!c) i = 3;
			fseek(inputFile,fpos-4,SEEK_SET); fread(&c,1,1,inputFile); if (!c) i = 3;
			i++;
			}
		fpos--;
		}
		fseek(inputFile,fpos,SEEK_SET); goto again;
		}
		fpos++;
		}
		}
    printf("end at 0x%08X\n",ftell(inputFile));
		break;
///////////////////////////////////////////
		}
	case 0x53440011:
		{
///////////////////////////////////////////
		printf(" * DS2GeometryFile detected\n");

		fseek(inputFile,0x13,SEEK_SET);

		fread(&blkid,sizeof(unsigned short),1,inputFile); // version
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // chunk_begin
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // "meshes'
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&mcntw,2,1,inputFile); // mesh count
		printf("mesh count = %u\n",mcntw);
		fread(&i,3,1,inputFile); // DWORD pad = 0?
l_again:
		fread(&blkid,sizeof(unsigned short),1,inputFile); // shader
		if (blkid == 0) { fseek(inputFile,ftell(inputFile)+80-2,SEEK_SET); goto l_again; } // fix
	  //printf("* --> fpos = 0x%08X\n",ftell(inputFile)-2);
		char * m_shd = new char[blkid+1];
		fread(m_shd,blkid,1,inputFile); 
	  m_shd[blkid] = 0;
	  printf("(%u): shader : '%s', ",cntw,m_shd);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // texture

		char * tmpdata = new char[blkid];
		fread(tmpdata,blkid,1,inputFile); 
		unsigned int tstart = 0, tend = blkid;
		for (fpos = 0; fpos < blkid; fpos++)
		{
		if (tmpdata[fpos] == '\\') fpos++, tstart = fpos;
		}
		tend = fpos;
		char * m_dds = new char[tend - tstart + 1];
		memcpy(m_dds,&tmpdata[tstart],tend - tstart); 
    m_dds[tend - tstart] = 0;
	  printf("texture : '%s'\n",m_dds);
		delete [] tmpdata;

		fread(&blkid,sizeof(unsigned short),1,inputFile); // unk, 'notexture'
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // unk, 'notexture'
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // unk, 'notexture'
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // unk, 'notexture'
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos+258,SEEK_SET);
		cntw++;

		if (cntw < mcntw) goto l_again;

		fread(&blkid,sizeof(unsigned short),1,inputFile); // shader
		if (blkid == 0) { fseek(inputFile,ftell(inputFile)+80-2,SEEK_SET); } // fix#2

		fpos = ftell(inputFile) - 1; fseek(inputFile,fpos,SEEK_SET); // skip 1 back
	  printf("** --> fpos = 0x%08X\n",fpos);

		fread(&blkid,sizeof(unsigned short),1,inputFile); // chunk_end
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // chunk_begin
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);
		fread(&blkid,sizeof(unsigned short),1,inputFile); // 'buffers'
		fpos = ftell(inputFile) + blkid; fseek(inputFile,fpos,SEEK_SET);

		fpos = ftell(inputFile); fseek(inputFile,fpos,SEEK_SET);
	  printf("*** --> fpos = 0x%08X (%u)\n",fpos,fpos);

		fread(&i,4,1,inputFile); printf("???#1 = %u\n",i);
		fread(&i,4,1,inputFile); printf("???#2 = %u\n",i);
		fread(&i,4,1,inputFile); printf("???#3 = %u\n",i);

		fpos = ftell(inputFile); fseek(inputFile,fpos,SEEK_SET);
	  printf("**** --> fpos = 0x%08X (%u)\n",fpos,fpos);

		printf("float(3) - vtx\n");
		if (oobj) printf("# vertices : %u\n", i);
		for (j = 0; j < i;j++)
		{
		fread(&f,4,1,inputFile); // if (oobj) printf("v %f ",f);
		fread(&f,4,1,inputFile); // if (oobj) printf("%f ",f);
		fread(&f,4,1,inputFile); // if (oobj) printf("%f\n",f);
		}

		fpos = ftell(inputFile); fseek(inputFile,fpos,SEEK_SET);
	  printf("**** --> fpos = 0x%08X (%u)\n",fpos,fpos);

		printf("float(4) - n\n");
		for (j = 0; j < i;j++)
		{
		fread(&f,4,1,inputFile); // if (oobj) printf("vn %f ",f); // printf("?? = %f, ",f);
		fread(&f,4,1,inputFile); // if (oobj) printf("%f ",f); // printf("%f, ",f);
		fread(&f,4,1,inputFile); // if (oobj) printf("%f\n",f); // printf("%f, ",f);
		fread(&f,4,1,inputFile); // printf("%f\n",f);
		}

		fpos = ftell(inputFile); fseek(inputFile,fpos,SEEK_SET);
	  printf("***** --> fpos = 0x%08X (%u)\n",fpos,fpos);

		fread(&i,4,1,inputFile); printf("???#1 = %u\n",i);
		fread(&i,4,1,inputFile); printf("???#2 = %u\n",i);

		printf("int(1) - indices\n");
		if (oobj) printf("# indices : %u\n", i);
		if (oobj) printf("# faces : %u\n", i/3);
		for (j = 0; j < i;j+=3)
		{
		fread(&k,4,1,inputFile); // if (oobj) printf("f %u/%u/%u ",k,k,k);
		fread(&k,4,1,inputFile); // if (oobj) printf("%u/%u/%u ",k,k,k);
		fread(&k,4,1,inputFile); // if (oobj) printf("%u/%u/%u\n",k,k,k);
		}

		fpos = ftell(inputFile); fseek(inputFile,fpos,SEEK_SET);
	  printf("****** --> fpos = 0x%08X (%u)\n",fpos,fpos);

		fread(&i,4,1,inputFile); printf("???#1 = %u\n",i);
		fread(&i,4,1,inputFile); printf("???#2 = %u\n",i);

		printf("float(3) - vtx2\n");
		for (j = 0; j < i;j++)
		{
		fread(&f,4,1,inputFile); // printf("v = %f, ",f);
		fread(&f,4,1,inputFile); // printf("%f, ",f);
		fread(&f,4,1,inputFile); // printf("%f\n",f);
		}

		fpos = ftell(inputFile); fseek(inputFile,fpos,SEEK_SET);
	  printf("******* --> fpos = 0x%08X (%u)\n",fpos,fpos);

		printf("float(2) - ?\n");
		for (j = 0; j < i;j++)
		{
		fread(&f,4,1,inputFile); // printf("?? = %f, ",f);
		fread(&f,4,1,inputFile); // printf("%f\n",f);
		}

/////////////////////////////////////////////////////////////////////////////////

		fpos = ftell(inputFile); fseek(inputFile,fpos,SEEK_SET);
	  printf("******** --> fpos = 0x%08X (%u)\n",fpos,fpos);

		printf("int(4) - ?\n");
		for (j = 0; j < i;j++)
		{
		fread(&k,4,1,inputFile); // printf("???# = %u, ",k);
		fread(&k,4,1,inputFile); // printf("%u, ",k);
		fread(&k,4,1,inputFile); // printf("%u, ",k);
		fread(&k,4,1,inputFile); // printf("%u\n",k);
		}

		fpos = ftell(inputFile); fseek(inputFile,fpos,SEEK_SET);
	  printf("********* --> fpos = 0x%08X (%u)\n",fpos,fpos);

		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);
		fread(&f,4,1,inputFile); printf("? = %f\n",f);

		break;
///////////////////////////////////////////
		}
	default:
		{
///////////////////////////////////////////
		printf(" ! unknown type detected = 0x%08X\n",i);
		break;
///////////////////////////////////////////
		}
	}
	if (inputFile) fclose(inputFile);
	return 0;
	}
